﻿Public Class Launch

    Private DashboardWelcome As UI.TabViews.Welcome = Nothing
    Private WithEvents Dashboard As UI.TabViews.Dashboard = Nothing
    Private StorageAccount As UI.TabViews.StorageAccount = Nothing
    Private WithEvents BackupSchedule As UI.TabViews.BackupSchedule = Nothing
    Private History As UI.TabViews.History = Nothing

    Private Sub ActiveTabInterface(ByVal ActiveTabText As String)
        RibbonPanelMain.Controls.Clear()
        If ActiveTabText = "Welcome" Then
            If Dashboard Is Nothing Then
                DashboardWelcome = New UI.TabViews.Welcome
                DashboardWelcome.Location = New Point(0, 0)
                DashboardWelcome.Dock = DockStyle.Fill
            End If
            RibbonPanelMain.Controls.Add(DashboardWelcome)
        ElseIf ActiveTabText = "Dashboard" Then
            If Dashboard Is Nothing Then
                Dashboard = New UI.TabViews.Dashboard
                Dashboard.Location = New Point(0, 0)
                Dashboard.Dock = DockStyle.Fill
            End If
            RibbonPanelMain.Controls.Add(Dashboard)
        ElseIf ActiveTabText = "Storage Account" Then
            If StorageAccount Is Nothing Then
                StorageAccount = New UI.TabViews.StorageAccount
                StorageAccount.Location = New Point(0, 0)
                StorageAccount.Dock = DockStyle.Fill
            End If
            RibbonPanelMain.Controls.Add(StorageAccount)
        ElseIf ActiveTabText = "Backup Schedule" Then
            If BackupSchedule Is Nothing Then
                BackupSchedule = New UI.TabViews.BackupSchedule
                BackupSchedule.Location = New Point(0, 0)
                BackupSchedule.Dock = DockStyle.Fill
            End If
            RibbonPanelMain.Controls.Add(BackupSchedule)
        ElseIf ActiveTabText = "History" Then
            If History Is Nothing Then
                History = New UI.TabViews.History
                History.Location = New Point(0, 0)
                History.Dock = DockStyle.Fill
            End If
            RibbonPanelMain.Controls.Add(History)
        End If
    End Sub

    Private Sub LaunchOptionDialog()
        UI.Options.OptionDialog.ShowDialog()
    End Sub

    Private Sub LaunchBackupWizard()
        UI.Wizard.BackupWizard.ShowDialog()
    End Sub

    Private Sub LaunchRestoreWizard()
        UI.Wizard.RestoreWizard.ShowDialog()
    End Sub

    Private Sub LaunchCreateStorageAccount()
        UI.StorageAccount.CreateStorageAccount.ShowDialog()
    End Sub

    Private Sub LaunchCreateS3Account()
        UI.StorageAccount.CreateAmazonS3.ShowDialog()
    End Sub

    Private Sub Ribbon1_ActiveTabChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles RibbonForm.ActiveTabChanged
        ActiveTabInterface(RibbonForm.ActiveTab.Text)
    End Sub

    Private Sub Ribbon1_RibbonApplicationMenuExitButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonForm.RibbonApplicationMenuExitButtonClick
        Application.Exit()
    End Sub

    Private Sub Launch_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        'Initialize Title
        Me.Text = UI.Base.Common.TitleApplication
        Me.RibbonForm.Text = UI.Base.Common.TitleApplication
        'Initialize Controls
        Me.RibbonForm.DropShadow = True
        ActiveTabInterface("Dashboard")
        'Demo Amazon Accounts
        Dim menuItem As PureComponents.ActionSet.Items.RibbonMenuItem = Nothing
        'Sample accounts
        For i As Integer = 1 To 3
            menuItem = New PureComponents.ActionSet.Items.RibbonMenuItem()
            menuItem.Text = "Sample Account " & i.ToString
            menuItem.Description = "Select account to view data"
            menuItem.Image = Me.RibbonDropDownButtonS3Account.Image
            Me.RibbonDropDownButtonS3Account.MenuItems.Add(menuItem)
        Next

        For i As Integer = 1 To 5
            menuItem = New PureComponents.ActionSet.Items.RibbonMenuItem()
            menuItem.Text = "Backup Job " & i.ToString
            menuItem.Description = "Select backup job to view data"
            menuItem.Image = Me.RibbonDropDownButton2.Image
            Me.RibbonDropDownButton2.MenuItems.Add(menuItem)
        Next
        Dashboard.StartService()
        If My.Computer.Network.IsAvailable Then
            RibbonStatusBarButtonNetwork.ScreenTip.Description = "Network is available"
        Else
            RibbonStatusBarButtonNetwork.ScreenTip.Description = "Network is not available"
        End If
    End Sub

    Private Sub RibbonForm_RibbonApplicationMenuOptionsButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonForm.RibbonApplicationMenuOptionsButtonClick
        LaunchOptionDialog()
    End Sub

    Private Sub RibbonDropDownButtonService_MenuItemClick(ByVal sender As System.Object, ByVal e As PureComponents.ActionSet.RibbonUI.RibbonMenuItemEventArgs) Handles RibbonDropDownButtonService.MenuItemClick
        If e.MenuItem Is Me.RibbonMenuTopLevelItemStartService Then
            Dashboard.StartService()
        ElseIf e.MenuItem Is Me.RibbonMenuTopLevelItemStopService Then
            Dashboard.StopService()
        End If
    End Sub

    Private Sub RibbonForm_RibbonApplicationMenuItemClick(ByVal sender As Object, ByVal e As PureComponents.ActionSet.RibbonUI.RibbonMenuItemEventArgs) Handles RibbonForm.RibbonApplicationMenuItemClick
        If e.MenuItem Is Me.RibbonMenuTopLevelItemClose Then
            Me.RibbonForm.ApplicationButton.Hide()
        ElseIf e.MenuItem Is Me.RibbonMenuItemLaunchBackupWizard Then
            LaunchBackupWizard()
        ElseIf e.MenuItem Is Me.RibbonMenuItemLaunchRestoreWizard Then
            LaunchRestoreWizard()
        ElseIf e.MenuItem Is Me.RibbonMenuItemCreateStorage Then
            LaunchCreateStorageAccount()
        ElseIf e.MenuItem Is Me.RibbonMenuItemBackupPlan Then
            LaunchBackupWizard()
        End If
    End Sub

    Private Sub RibbonButtonRestoreWizard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonButtonRestoreWizard.Click
        LaunchRestoreWizard()
    End Sub

    Private Sub RibbonButtonBackupWizard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonButtonBackupWizard.Click
        LaunchBackupWizard()
    End Sub

    Private Sub RibbonButtonRestoreWizard2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonButtonRestoreWizard2.Click
        LaunchRestoreWizard()
    End Sub

    Private Sub RibbonButtonBackupWizard2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonButtonBackupWizard2.Click
        LaunchBackupWizard()
    End Sub

    Private Sub RibbonButtonStorageAccount_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonButtonStorageAccount.Click
        LaunchCreateStorageAccount()
    End Sub

    Private Sub RibbonButtonStorageAccount2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonButtonStorageAccount2.Click
        LaunchCreateStorageAccount()
    End Sub

    Private Sub RibbonButtonAmazonS3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonButtonAmazonS3.Click
        LaunchCreateS3Account()
    End Sub

    Private Sub RibbonGroupPanelStorage_DialogLauncherClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonGroupPanelStorage.DialogLauncherClick
        LaunchCreateStorageAccount()
    End Sub

    Private Sub RibbonGroupPanelAmazonS3_DialogLauncherClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonGroupPanelAmazonS3.DialogLauncherClick
        LaunchCreateS3Account()
    End Sub

    Private Sub Dashboard_OnServiceStart() Handles Dashboard.OnServiceStart
        RibbonStatusBarButtonService.Image = My.Resources.ServiceUp16
        RibbonStatusBarButtonService.ScreenTip.Description = "Backup service running"
    End Sub

    Private Sub Dashboard_OnServiceStop() Handles Dashboard.OnServiceStop
        RibbonStatusBarButtonService.Image = My.Resources.ServiceDown16
        RibbonStatusBarButtonService.ScreenTip.Description = "Backup service stopped"
    End Sub

    Private Sub BackupSchedule_OnShowBackupHistory() Handles BackupSchedule.OnShowBackupHistory
        Me.RibbonForm.ActiveTab = Me.RibbonTabHistory
    End Sub
End Class