﻿Namespace Storage.AmazonS3

    Public Class S3Directory
        Implements Storage.Base.IStorageDirectory

        Private _Name As String
        Private _FullName As String

        Public Shared ReadOnly Property DirectorySeparator As String
            Get
                Return "/"
            End Get
        End Property

        Public Property FullName As String Implements Base.IStorageDirectory.FullName
            Get
                Return _FullName
            End Get
            Set(ByVal value As String)
                _FullName = value
            End Set
        End Property

        Public Property Name As String Implements Base.IStorageDirectory.Name
            Get
                Return _Name
            End Get
            Set(ByVal value As String)
                _Name = value
            End Set
        End Property

        Public Sub New(ByVal name As String, ByVal fullName As String)
            Me.Name = name
            Me.FullName = fullName
        End Sub

        Public Shared Function GetFileSystemEntries(ByVal directoryPath As String) As System.Collections.Generic.List(Of Base.IStorageDirectory)
            'key = CBB_NAZIM/C:/Documents and Settings/All Users/Documents/My Pictures/Sample Pictures/Blue hills.jpg
            'Size = 28521
            Dim storageDirectory As Base.IStorageDirectory
            GetFileSystemEntries = New System.Collections.Generic.List(Of Base.IStorageDirectory)
            If directoryPath = "nazim" Then
                storageDirectory = New AmazonS3.S3Directory("C:/", "C:/")
            Else
                storageDirectory = New AmazonS3.S3Directory("Test", "C:/Test")
            End If

            GetFileSystemEntries.Add(storageDirectory)

        End Function

        Public Shared Function GetFiles(ByVal directoryPath As String) As System.Collections.Generic.List(Of Base.IStorageFile)
            'key = CBB_NAZIM/C:/Documents and Settings/All Users/Documents/My Pictures/Sample Pictures/Blue hills.jpg
            'Size = 28521
            Dim storageFile As Base.IStorageFile
            GetFiles = New System.Collections.Generic.List(Of Base.IStorageFile)
            storageFile = New AmazonS3.S3File("test.jpg", directoryPath & DirectorySeparator & "abc/test.jpg", 2048, Now)
            GetFiles.Add(storageFile)

        End Function

    End Class

End Namespace