﻿Namespace Storage.AmazonS3

    Public Class S3File
        Implements Storage.Base.IStorageFile

        Private _Name As String
        Private _FullName As String
        Private _CreationTime As Date
        Private _Length As Long
        Private _DirectoryName As String
        Private _Extension As String

        Public Sub New(ByVal name As String, ByVal fullName As String, ByVal fileSize As Long, ByVal creationTime As Date)
            Me.Name = name
            Me.FullName = fullName
            Me.CreationTime = creationTime
            Me._Length = fileSize
            Me._DirectoryName = fullName.Substring(0, fullName.LastIndexOf(S3Directory.DirectorySeparator) + 1)
            Me._Extension = fullName.Substring(fullName.LastIndexOf(S3File.FileExtensionSeparator))
        End Sub

        Public Shared ReadOnly Property FileExtensionSeparator As String
            Get
                Return "."
            End Get
        End Property

        Public Property FullName As String Implements Base.IStorageFile.FullName
            Get
                Return _FullName
            End Get
            Set(ByVal value As String)
                _FullName = value
            End Set
        End Property

        Public Property Name As String Implements Base.IStorageFile.Name
            Get
                Return _Name
            End Get
            Set(ByVal value As String)
                _Name = value
            End Set
        End Property

        Public Property CreationTime As Date Implements Base.IStorageFile.CreationTime
            Get
                Return _CreationTime
            End Get
            Set(ByVal value As Date)
                _CreationTime = value
            End Set
        End Property

        Public Property Length As Long Implements Base.IStorageFile.Length
            Get
                Return _Length
            End Get
            Set(ByVal value As Long)
                _Length = value
            End Set
        End Property

        Public ReadOnly Property DirectoryName As String Implements Base.IStorageFile.DirectoryName
            Get
                Return _DirectoryName
            End Get
        End Property

        Public ReadOnly Property Extension As String Implements Base.IStorageFile.Extension
            Get
                Return _Extension
            End Get
        End Property

    End Class

End Namespace