Imports System.IO

Namespace Storage.FileSystem

    Friend Class FolderSize

        Private directoryPath As String
        Private folderSizeCalculated As Long
        Private processThread As Threading.Thread
        Private stopProcess As Boolean
        Private done As Boolean

        Public Sub New(ByVal DirPath As String)
            directoryPath = DirPath
            stopProcess = False
            done = False
        End Sub

        ReadOnly Property SizeInBtyes() As Long
            Get
                Return folderSizeCalculated
            End Get
        End Property

        ReadOnly Property IsDone() As Boolean
            Get
                Return done
            End Get
        End Property

        ReadOnly Property FolderSize() As String
            Get
                Return CStr(FileSize.GetSize(folderSizeCalculated))
            End Get
        End Property

        Private Sub GetFoldersSize(ByVal DirPath As String)
            System.Windows.Forms.Application.DoEvents()
            GetFolderSize(DirPath, True)
        End Sub

        Private Sub GetFolderSize(ByVal DirectoryPath As String, ByVal IncludeSubFolders As Boolean)
            Try
                Dim size As Long = 0
                Dim diBase As New DirectoryInfo(DirectoryPath)
                Dim files() As FileInfo
                If IncludeSubFolders Then
                    files = diBase.GetFiles("*", SearchOption.AllDirectories)
                Else
                    files = diBase.GetFiles("*", SearchOption.TopDirectoryOnly)
                End If
                Dim ie As IEnumerator = files.GetEnumerator
                While ie.MoveNext And Not stopProcess
                    folderSizeCalculated += DirectCast(ie.Current, FileInfo).Length
                End While
            Catch ex As Exception
                folderSizeCalculated = 0
            End Try
        End Sub

        Private Sub CalculateFolderSize()
            GetFoldersSize(directoryPath)
            done = True
            processThread = Nothing
        End Sub

        Public Sub StartCalculating()
            processThread = New Threading.Thread(AddressOf CalculateFolderSize)
            processThread.SetApartmentState(Threading.ApartmentState.STA)
            processThread.Start()
        End Sub

        Public Sub StopCalculating()
            stopProcess = True
        End Sub

    End Class

End Namespace