Namespace UI.Controls

    Public Class DirectoryExplorer

        Private FilesSelected As New System.Collections.Generic.List(Of String)
        Private Explorer As Storage.Base.IExplorer

        Private Sub fillDrives()
            Explorer.FillNodesInTreeView(trv_Directory)
        End Sub

        Private Sub trv_Directory_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles trv_Directory.AfterSelect
            If Me.Cursor = Cursors.WaitCursor Then Exit Sub
            Me.Cursor = Cursors.WaitCursor
            Try
                If trv_Directory.SelectedNode.IsExpanded = False Then
                    Explorer.FillFilesInTreeNode(trv_Directory.SelectedNode.Tag, trv_Directory.SelectedNode)
                    Explorer.FillDirectoryInTreeNode(trv_Directory.SelectedNode.Tag, trv_Directory.SelectedNode)
                End If
            Catch ex As Exception

            Finally
                Me.Cursor = Cursors.Arrow
                trv_Directory.Focus()
            End Try
        End Sub

        Private Sub trv_Directory_AfterCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles trv_Directory.AfterCheck
            If Me.Cursor = Cursors.WaitCursor Then Exit Sub
            Me.Cursor = Cursors.WaitCursor
            Try
                If e.Node.Checked Then
                    FilesSelected.Add(e.Node.Tag)
                Else
                    FilesSelected.Remove(e.Node.Tag)
                End If

                If e.Node.IsExpanded = False Then
                    Explorer.FillDirectoryInTreeNode(e.Node.Tag, e.Node)
                End If

                For i As Integer = 0 To e.Node.Nodes.Count - 1
                    e.Node.Nodes(i).Checked = e.Node.Checked
                Next
            Catch ex As Exception

            Finally
                Me.Cursor = Cursors.Arrow
                trv_Directory.Focus()
            End Try
        End Sub

        Private Sub BrwCtrl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            Me.Explorer = New Storage.FileSystem.Explorer(0, 0, 1, 1)
            Me.fillDrives()
        End Sub

    End Class

End Namespace