Namespace UI.Controls

    Public Class FileSystemExplorer

        Private FilesSelected As New System.Collections.Generic.List(Of String)
        Private Explorer As Storage.Base.IExplorer

        Private Sub fillDrives()
            Explorer.FillNodesInTreeView(trv_Directory)
        End Sub

        Private Sub trv_Directory_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles trv_Directory.AfterSelect
            If Me.Cursor = Cursors.WaitCursor Then Exit Sub
            Try
                Me.Cursor = Cursors.WaitCursor
                PanelDir.Enabled = False
                PanelFile.Enabled = False

                If trv_Directory.SelectedNode.IsExpanded = False Then
                    Explorer.FillFilesInListView(trv_Directory.SelectedNode.Tag, lstv_Files)
                    For i As Integer = 0 To lstv_Files.Items.Count - 1
                        lstv_Files.Items.Item(i).Checked = e.Node.Checked
                        If FilesSelected.Contains(lstv_Files.Items(i).Tag) Then
                            lstv_Files.Items.Item(i).Checked = True
                        End If
                    Next
                    Explorer.FillDirectoryInTreeNode(trv_Directory.SelectedNode.Tag, trv_Directory.SelectedNode)
                End If
            Catch ex As Exception

            Finally
                PanelDir.Enabled = True
                PanelFile.Enabled = True
                Me.Cursor = Cursors.Arrow
                trv_Directory.Focus()
            End Try
        End Sub

        Private Sub trv_Directory_AfterCheck(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles trv_Directory.AfterCheck
            If Me.Cursor = Cursors.WaitCursor Then Exit Sub
            Try
                Me.Cursor = Cursors.WaitCursor
                PanelDir.Enabled = False
                PanelFile.Enabled = False

                If e.Node.IsExpanded = False Then
                    Explorer.FillDirectoryInTreeNode(e.Node.Tag, e.Node)
                End If
                Dim str As String

                For i As Integer = 0 To lstv_Files.Items.Count - 1
                    str = lstv_Files.Items.Item(i).SubItems(4).Text
                    If e.Node.Tag = str Then
                        lstv_Files.Items.Item(i).Checked = e.Node.Checked
                    End If
                Next

                For i As Integer = 0 To e.Node.Nodes.Count - 1
                    e.Node.Nodes.Item(i).Checked = e.Node.Checked
                Next
            Catch ex As Exception

            Finally
                PanelDir.Enabled = True
                PanelFile.Enabled = True
                Me.Cursor = Cursors.Arrow
                trv_Directory.Focus()
            End Try
        End Sub

        Private Sub BrwCtrl_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            Me.Explorer = New Storage.FileSystem.Explorer(0, 0, 1, 1)
            Me.fillDrives()
            Me.lstv_Files.Items.Clear()
        End Sub

        Private Sub lstv_Files_ItemChecked(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckedEventArgs) Handles lstv_Files.ItemChecked
            Dim lstItem As ListViewItem = e.Item
            If lstItem.Checked Then
                FilesSelected.Add(lstItem.Tag)
            Else
                FilesSelected.Remove(lstItem.Tag)
            End If
        End Sub
    End Class

End Namespace