﻿Namespace UI.StorageAccount

    Public Class CreateStorageAccount

        Private Sub BackupWizard_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            'Initialize Title
            Me.Text = UI.Base.Common.TitleBackupWizardDialog
            Me.RibbonFormCreate.Text = UI.Base.Common.TitleCreateStorageAccountDialog
            Me.PictureBoxLogo.Image = Global.IBackupCloud.My.Resources.Resources.amazon_s3_icon48

            Me.ListViewAccount.Items.Add("My Storage 1", 0)
            Me.ListViewAccount.Items.Add("My Storage 2", 0)
            Me.ListViewAccount.Items.Add("My Storage 3", 0)
        End Sub

        Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClose.Click
            Me.Close()
        End Sub

        Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAdd.Click
            CreateAmazonS3.ShowDialog()
        End Sub

        Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonEdit.Click
            If ListViewAccount.SelectedItems.Count > 0 Then
                CreateAmazonS3.ShowDialog()
            Else
                MessageBox.Show("Please select account to edit its settings.", "No Account", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End Sub

        Private Sub ButtonCreate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCreate.Click
            UI.Base.Common.LaunchAmazonS3Website()
        End Sub

        Private Sub ButtonDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonDelete.Click
            If ListViewAccount.SelectedItems.Count > 0 Then
                MessageBox.Show("Storage account deleted successfully.", "Account Deleted", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Else
                MessageBox.Show("Please select account to edit its settings.", "No Account", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            End If
        End Sub
    End Class

End Namespace