﻿Namespace UI.TabViews

    Public Class Dashboard

        Private serviceStarted As Boolean = False
        Public Event OnServiceStart()
        Public Event OnServiceStop()

        Private Sub Dashboard_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

            Dim backupJob As UI.Controls.BackupJob = Nothing
            Dim storageOverview As UI.Controls.StorageOverview = Nothing

            For i As Integer = 1 To 3 Step 1
                storageOverview = New UI.Controls.StorageOverview
                storageOverview.LabelTitle.Text = "My Storage " & i.ToString
                ScrollablePanelStorage.ControlItems.Add(storageOverview)

            Next

            For i As Integer = 1 To 5 Step 1
                backupJob = New UI.Controls.BackupJob
                backupJob.LabelTitle.Text = "Backup Job " & i.ToString
                ScrollablePanelBackup.ControlItems.Add(backupJob)
            Next

        End Sub

        Private Sub RibbonButtonStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RibbonButtonStart.Click
            If serviceStarted = True Then
                StopService()
            Else
                StartService()
            End If

        End Sub

        Public Sub StartService()
            PictureBoxService.Image = My.Resources.ServiceUp
            LabelServiceStatus.Text = "Backup service started"
            RibbonButtonStart.Image = My.Resources.StopService
            serviceStarted = True
            RaiseEvent OnServiceStart()
        End Sub

        Public Sub StopService()
            PictureBoxService.Image = My.Resources.ServiceDown
            LabelServiceStatus.Text = "Backup service stopped"
            RibbonButtonStart.Image = My.Resources.StartService
            serviceStarted = False
            RaiseEvent OnServiceStop()
        End Sub
    End Class

End Namespace