﻿Namespace UI.Wizard

    Public Class BackupWizard

        Private Enum WizardViews As Integer
            Welcome = 0
            SelectAccount = 1
            SelectSource = 2
            AdvanceFilter = 3
            CompressionOption = 4
            PurgeOption = 5
            ScheduleOption = 6
            Notification = 7
            PlanName = 8
            Summary = 9
            Finish = 10
        End Enum

        Private BackupWelcome As UI.Wizard.Backup.Welcome = Nothing
        Private BackupSelectAccount As UI.Wizard.Backup.SelectAccount = Nothing
        Private BackupSelectSource As UI.Wizard.Backup.SelectSource = Nothing
        Private BackupAdvanceFilter As UI.Wizard.Backup.AdvanceFilter = Nothing
        Private BackupCompressionOption As UI.Wizard.Backup.CompressionOption = Nothing
        Private BackupPurgeOption As UI.Wizard.Backup.PurgeOption = Nothing
        Private BackupScheduleOption As UI.Wizard.Backup.ScheduleOption = Nothing
        Private BackupNotification As UI.Wizard.Backup.Notification = Nothing
        Private BackupPlanName As UI.Wizard.Backup.PlanName = Nothing
        Private BackupSummary As UI.Wizard.Backup.Summary = Nothing
        Private BackupFinish As UI.Wizard.Backup.Finish = Nothing
        Private CurrentView As WizardViews = WizardViews.Welcome

        Private Sub ActiveWizardView(ByVal wizardView As WizardViews)
            PanelWizard.Controls.Clear()
            If wizardView = WizardViews.Welcome Then
                Me.PanelWizard.Controls.Add(BackupWelcome)
                Me.ButtonBack.Enabled = False
            ElseIf wizardView = WizardViews.SelectAccount Then
                Me.PanelWizard.Controls.Add(BackupSelectAccount)
            ElseIf wizardView = WizardViews.SelectSource Then
                Me.PanelWizard.Controls.Add(BackupSelectSource)
            ElseIf wizardView = WizardViews.AdvanceFilter Then
                Me.PanelWizard.Controls.Add(BackupAdvanceFilter)
            ElseIf wizardView = WizardViews.CompressionOption Then
                Me.PanelWizard.Controls.Add(BackupCompressionOption)
            ElseIf wizardView = WizardViews.PurgeOption Then
                Me.PanelWizard.Controls.Add(BackupPurgeOption)
            ElseIf wizardView = WizardViews.ScheduleOption Then
                Me.PanelWizard.Controls.Add(BackupScheduleOption)
            ElseIf wizardView = WizardViews.Notification Then
                Me.PanelWizard.Controls.Add(BackupNotification)
            ElseIf wizardView = WizardViews.PlanName Then
                Me.PanelWizard.Controls.Add(BackupPlanName)
            ElseIf wizardView = WizardViews.Summary Then
                Me.PanelWizard.Controls.Add(BackupSummary)
            ElseIf wizardView = WizardViews.Finish Then
                Me.PanelWizard.Controls.Add(BackupFinish)
                Me.ButtonNext.Text = "Finish"
            End If
        End Sub

        Private Sub BackupWizard_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            'Initialize Title
            Me.Text = UI.Base.Common.TitleBackupWizardDialog
            Me.RibbonFormWizard.Text = UI.Base.Common.TitleBackupWizardDialog

            'Initialize Controls
            BackupWelcome = New UI.Wizard.Backup.Welcome
            BackupWelcome.Dock = DockStyle.Fill

            BackupSelectAccount = New UI.Wizard.Backup.SelectAccount
            BackupSelectAccount.Dock = DockStyle.Fill

            BackupSelectSource = New UI.Wizard.Backup.SelectSource
            BackupSelectSource.Dock = DockStyle.Fill

            BackupAdvanceFilter = New UI.Wizard.Backup.AdvanceFilter
            BackupAdvanceFilter.Dock = DockStyle.Fill

            BackupCompressionOption = New UI.Wizard.Backup.CompressionOption
            BackupCompressionOption.Dock = DockStyle.Fill

            BackupPurgeOption = New UI.Wizard.Backup.PurgeOption
            BackupPurgeOption.Dock = DockStyle.Fill

            BackupScheduleOption = New UI.Wizard.Backup.ScheduleOption
            BackupScheduleOption.Dock = DockStyle.Fill

            BackupNotification = New UI.Wizard.Backup.Notification
            BackupNotification.Dock = DockStyle.Fill

            BackupPlanName = New UI.Wizard.Backup.PlanName
            BackupPlanName.Dock = DockStyle.Fill

            BackupSummary = New UI.Wizard.Backup.Summary
            BackupSummary.Dock = DockStyle.Fill

            BackupFinish = New UI.Wizard.Backup.Finish
            BackupFinish.Dock = DockStyle.Fill

            'Set Initial view
            ActiveWizardView(CurrentView)
        End Sub

        Private Sub ButtonNext_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ButtonNext.Click
            If Me.ButtonNext.Text = "Finish" Then
                Me.Close()
                Me.Dispose()
            Else
                If CurrentView < WizardViews.Finish Then
                    CurrentView = CurrentView + 1
                    ActiveWizardView(CurrentView)
                    Me.ButtonBack.Enabled = True
                Else
                    Me.ButtonNext.Text = "Finish"
                End If
            End If
        End Sub

        Private Sub ButtonBack_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ButtonBack.Click
            If CurrentView > WizardViews.Welcome Then
                CurrentView = CurrentView - 1
                ActiveWizardView(CurrentView)
                Me.ButtonNext.Text = "Next"
            Else
                Me.ButtonBack.Enabled = False
            End If
        End Sub

        Private Sub ButtonCancel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click
            Me.Close()
            Me.Dispose()
        End Sub
    End Class

End Namespace