﻿Namespace UI.Wizard

    Public Class RestoreWizard

        Private Enum WizardViews As Integer
            Welcome = 0
            SelectAccount = 1
            SelectSource = 2
            SelectDestination = 3
            Summary = 4
            Finish = 5
        End Enum

        Private RestoreWelcome As UI.Wizard.Restore.Welcome = Nothing
        Private RestoreSelectAccount As UI.Wizard.Restore.SelectAccount = Nothing
        Private RestoreSelectSource As UI.Wizard.Restore.SelectSource = Nothing
        Private RestoreSelectDestination As UI.Wizard.Restore.SelectDestination = Nothing
        Private RestoreSummary As UI.Wizard.Restore.Summary = Nothing
        Private RestoreFinish As UI.Wizard.Restore.Finish = Nothing
        Private CurrentView As WizardViews = WizardViews.Welcome

        Private Sub ActiveWizardView(ByVal wizardView As WizardViews)
            PanelWizard.Controls.Clear()
            If wizardView = WizardViews.Welcome Then
                Me.PanelWizard.Controls.Add(RestoreWelcome)
                Me.ButtonBack.Enabled = False
            ElseIf wizardView = WizardViews.SelectAccount Then
                Me.PanelWizard.Controls.Add(RestoreSelectAccount)
            ElseIf wizardView = WizardViews.SelectSource Then
                Me.PanelWizard.Controls.Add(RestoreSelectSource)
            ElseIf wizardView = WizardViews.SelectDestination Then
                Me.PanelWizard.Controls.Add(RestoreSelectDestination)
            ElseIf wizardView = WizardViews.Summary Then
                Me.PanelWizard.Controls.Add(RestoreSummary)
            ElseIf wizardView = WizardViews.Finish Then
                Me.PanelWizard.Controls.Add(RestoreFinish)
                Me.ButtonNext.Text = "Finish"
            End If
        End Sub

        Private Sub BackupWizard_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
            'Initialize Title
            Me.Text = UI.Base.Common.TitleRestoreWizardDialog
            Me.RibbonFormWizard.Text = UI.Base.Common.TitleRestoreWizardDialog

            'Initialize Controls
            RestoreWelcome = New UI.Wizard.Restore.Welcome
            RestoreWelcome.Dock = DockStyle.Fill

            RestoreSelectAccount = New UI.Wizard.Restore.SelectAccount
            RestoreSelectAccount.Dock = DockStyle.Fill

            RestoreSelectSource = New UI.Wizard.Restore.SelectSource
            RestoreSelectSource.Dock = DockStyle.Fill

            RestoreSelectDestination = New UI.Wizard.Restore.SelectDestination
            RestoreSelectDestination.Dock = DockStyle.Fill

            RestoreSummary = New UI.Wizard.Restore.Summary
            RestoreSummary.Dock = DockStyle.Fill

            RestoreFinish = New UI.Wizard.Restore.Finish
            RestoreSummary.Dock = DockStyle.Fill

            'Set Initial view
            ActiveWizardView(CurrentView)
        End Sub

        Private Sub ButtonNext_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ButtonNext.Click
            If Me.ButtonNext.Text = "Finish" Then
                Me.Close()
                Me.Dispose()
            Else
                If CurrentView < WizardViews.Finish Then
                    CurrentView = CurrentView + 1
                    ActiveWizardView(CurrentView)
                    Me.ButtonBack.Enabled = True
                Else
                    Me.ButtonNext.Text = "Finish"
                End If
            End If

        End Sub

        Private Sub ButtonBack_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ButtonBack.Click
            If CurrentView > WizardViews.Welcome Then
                CurrentView = CurrentView - 1
                ActiveWizardView(CurrentView)
                Me.ButtonNext.Text = "Next"
            Else
                Me.ButtonBack.Enabled = False
            End If
        End Sub

        Private Sub ButtonCancel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click
            Me.Close()
            Me.Dispose()
        End Sub
    End Class

End Namespace